Quassel IRC - Bug #682

Core crashes on client connection
04/25/2009 11:28 AM - seezer

Status: Resolved Start date: 04/25/2009
Priority: High Due date:

Assignee: % Done: 100%
Category: Quassel Core Estimated time: 0.00 hour
Target version:

Version: 0.5-pre 0S: Any
Description

Sometimes, right after pressing OK on the login credentials dialog, quasselcore crashes.
Only seems to occur on ssl encrypted client<->core connections.

This never happened to me with pre 0.4.0 cores but can't pinpoint any exact version.

Qt versions tested:
Qt 4.4.3 from debian lenny
Qt 4.5.0 built manually

Occured much less often to me since | upgraded to 4.5.0 but might be only coincidence.

Crashes look like:

Quassel IRC: 0.4.0 431ac220d932f46f298f7b43d0754d773a5f8ccc
Quassel IRC: 0.4.0 431ac220d932f46f298f7b43d0754d773a5f8ccc
. 0 quasselcore

.1 quasselcore

.2 libc.so.6

.3 libz.so0.1

.4 libz.so.1

.5 libz.so.1

.6 libz.so.1

. 7 libcrypto.s0.0.9.
. 8 libcrypto.s0.0.9.
.9 libssl.s0.0.9.8
.10 libssl.s0.0.9.8
.11 libssl.s0.0.9.8
. 12 libQtNetwork.so.4  0x00007f0eebed013f 0x0000000000000000

. 13 libQtNetwork.so.4  0x00007f0eebecd72c 0x0000000000000000

. 14 libQtNetwork.so.4  0x00007f0eebec6dbb QSsISocket::flush()

. 15 libQtNetwork.s0.4  0x00007f0eebec6e27 0x0000000000000000

. 16 libQtNetwork.so.4  0x00007f0eebec706¢c QSsISocket::qt_metacall(QMetaObject::Call, int, void**)
.17 libQtCore.s0.4
. 18 libQtCore.s0.4
.19 [ibQtCore.s0.4
. 20 libQtCore.s0.4
.21 libQtCore.so0.4
. 22 libQtCore.so0.4
. 23 libQtCore.s0.4
. 24 [ibQtCore.s0.4

QEventDispatche
25 libQtCore.so0.4
26 libQtCore.so0.4
27 libQtCore.s0.4
28 quasselcore

29 libQtCore.s0.4

0x000000000059119a Quassel::logBacktrace(QString const&)
0x0000000000574e22 Quassel::handleSignal(int)
0x00007f0eead9ff60 0x0000000000000000
0x00007f0eea95c671 0x0000000000000000
0x00007f0eea95d238 0x0000000000000000
0x00007f0eea95a5fc 0x0000000000000000
0x00007f0eea95928d deflate
8 0x00007f0ee9b1f88e 0x0000000000000000
8 0x00007f0ee9b1f4f2 COMP_compress_block
0x00007f0ee9dbb30e ssI3_do_compress
0x00007f0ee9dbb45¢ 0x0000000000000000
0x00007f0ee9dbb950 ssI3_write_bytes

0x00007f0eec2e2827 QMetaCallEvent::placeMetaCall(QObject*)
0x00007f0eec2e7545 QObject::event(QEvent*)
0x00007f0eec2cd59a QCoreApplicationPrivate::notify_helper(QObject*, QEvent*)
0x00007f0eec2d0b38 QCoreApplication::notify(QObject*, QEvent*)
0x00007f0eec2cf72b QCoreApplication::notifylnternal(QObject*, QEvent*)
0x00007f0eec2d41dd QCoreApplication::sendEvent(QObject*, QEvent*)
0x00007f0eec2cfd00 QCoreApplicationPrivate::sendPostedEvents(QObject*, int, QThreadData*)
0x00007f0eec30834c

rUNIX::processEvents(QFlags<QEventLoop::ProcessEventsFlag>)
0x00007f0eec2cbfcf QEventLoop::processEvents(QFlags<QEventLoop::ProcessEventsFlag>)
0x00007f0eec2cc1de QEventLoop::exec(QFlags<QEventLoop::ProcessEventsFlag>)
0x00007f0eec1b3dee QThread::exec()
0x00000000004bfcbd SessionThread::run()
0x00007f0eec1b870f 0x0000000000000000

30 libpthread.s0.0 ~ 0x00007f0eea534fc7 0x0000000000000000

31 libc.s0.6

0x00007f0eeae3d5ad clone
Associated revisions

Revision e042ae69dbe4f42e9e4441f4b5832cfe5¢ca89067 - 06/28/2009 04:08 PM - Marcus Eggenberger

An attempt to fix #682 - core crash on client connect when using ssl.
As I'm unable to reproduce this bug, I'm just following a hunch here.
Please let me know if it helps. seezer: ping!

Revision e042ae69 - 06/28/2009 04:08 PM - Marcus Eggenberger

An attempt to fix #682 - core crash on client connect when using ssl.
As I'm unable to reproduce this bug, I'm just following a hunch here.
Please let me know if it helps. seezer: ping!

Revision e049ffc61b5e260a49d73102a74¢3821af827e77 - 07/12/2009 03:16 PM - Marcus Eggenberger

Fixes #682 - Core crashes on client connection
Big thanks to seezer for debuging and researching!

Revision e049ffc6 - 07/12/2009 03:16 PM - Marcus Eggenberger

Fixes #682 - Core crashes on client connection
Big thanks to seezer for debuging and researching!

Revision 00fcb4ab7fd1a2af1c81d9cab13ee23fb7d7b73c - 07/12/2009 03:19 PM - Marcus Eggenberger

Fixes #682 - Core crashes on client connection
Big thanks to seezer for debuging and researching!

Revision 00fcb4ab - 07/12/2009 03:19 PM - Marcus Eggenberger
Fixes #682 - Core crashes on client connection

Big thanks to seezer for debuging and researching!

History

#1 - 04/25/2009 11:32 AM - Cybertinus

Also have the same problem with Quassel Core on Gentoo.

I've tried it with Qt 4.4 and 4.5.0 (haven't had a chrash with 4.5.1, but that is around for 2 days or so ;) ) and both chrashed. | used the Qt versions
Gentoo provided.

| just enabled the debug USE-flag on Gentoo. When it chrashes again | will attach that chrashlog.

#2 - 04/26/2009 03:48 PM - seezer

It's always one of two "different" crashlogs.
This is the other one:

Quassel IRC: 0.4.0 431ac220d932f46f298f7b43d0754d773a5f8ccc

1.0 quasselcore 0x000000000059119a Quassel::logBacktrace(QString const&)
2.1 quasselcore 0x0000000000574e22 Quassel::handleSignal(int)

3.2libc.so.6 0x00007f3cb9663f60 0x0000000000000000
4.3 libz.so.1 0x00007f3cb9220be9 0x0000000000000000
5.4 libz.so.1 0x000073cb9221052 0x0000000000000000
6.5 libz.so.1 0x00007f3cb921e5fc 0x0000000000000000
7.6 libz.so.1 0x00007f3cb921d28d deflate

8.7 libcrypto.s0.0.9.8  0x00007f3cb83e388e 0x0000000000000000
9. 8 libcrypto.s0.0.9.8  0x00007f3cb83e34f2 COMP_compress_block
10.9 libssl.s0.0.9.8  0x00007f3cb867f30e ssI3_do_compress
11.10 libssl.s0.0.9.8  0x00007f3cb867f45¢ 0x0000000000000000
12.11 libssl.s0.0.9.8  0x00007f3cb867f950 ssI3_write_bytes
13. 12 libQtNetwork.s0.4 0x00007f3cba79413f 0x0000000000000000
14. 13 libQtNetwork.s0.4  0x00007f3cba79172¢c 0x0000000000000000
15. 14 libQtNetwork.s0.4  0x00007f3cba78adbb QSsISocket::flush()
16. 15 libQtNetwork.s0.4  0x00007f3cba78ae27 0x0000000000000000
17.16 libQtNetwork.s0.4  0x00007f3cba78b06c QSsISocket::qt_metacall(QMetaObject::Call, int, void**)
18.17 libQtCore.s0.4 0x00007f3cbaba6827 QMetaCallEvent::placeMetaCall(QObject*)
19. 18 libQtCore.so0.4 0x00007f3cbabab545 QObject::event(QEvent®)
20.19 libQtCore.so0.4 0x00007f3cbab9159a QCoreApplicationPrivate::notify _helper(QObject*, QEvent*)
21.20 libQtCore.so0.4 0x00007f3cbab94b38 QCoreApplication::notify(QObject*, QEvent*)
22.21 libQtCore.so0.4 0x00007f3cbab9372b QCoreApplication::notifylnternal(QObject”, QEvent*)
23. 22 libQtCore.so0.4 0x00007f3cbab981dd QCoreApplication::sendEvent(QObject*, QEvent*)
24.23 libQtCore.so0.4 0x00007f3cbab93d00 QCoreApplicationPrivate::sendPostedEvents(QObject*, int, QThreadData*)
25. 24 libQtCore.so0.4 0x00007f3cbabcc34c QEventDispatcherUNIX::processEvents(QFlags<QEventLoop::ProcessEventsFlag>)
26. 25 libQtCore.so0.4 0x00007f3cbab8ffcf QEventLoop::processEvents(QFlags<QEventLoop::ProcessEventsFlag>)
27.26 libQtCore.so0.4 0x00007f3cbab901de QEventLoop::exec(QFlags<QEventLoop::ProcessEventsFlag>)
28
29
30
31
32
33
34
35
36
37
38
39
40

41.
42.
43.
44.

.27 libQtCore.so0.4
. 28 quasselcore
.29 libQtCore.so0.4
. 30 libpthread.s0.0
.31 libc.s0.6

.0 quasselcore

.1 quasselcore

.2 libc.so.6

.3 libz.s0.1

.4 libz.so.1

.5 libz.s0.1

.6 libz.so.1

0x00007f3cbaa77dee QThread::exec()
0x00000000004bfcbd SessionThread::run()
0x00007f3cbaa7c70f 0x0000000000000000
0x00007f3cb8df8fc7 0x0000000000000000
0x00007f3cb97015ad clone
0x000000000059119a Quassel::logBacktrace(QString const&)
0x0000000000574e22 Quassel::handleSignal(int)

0x00007f3cb9663f60 0x0000000000000000

0x000073cb9220671 0x0000000000000000
0x00007f3cb9221238 0x0000000000000000
0x00007f3cb921e5fc 0x0000000000000000

0x00007f3cb921d28d deflate

.7 libcrypto.s0.0.9.8  0x00007f3cb83e388e 0x0000000000000000

9 libssl.s0.0.9.8
10 libssl.s0.0.9.8
11 libssl.s0.0.9.8

8 libcrypto.s0.0.9.8 0x00007f3cb83e34f2 COMP_compress_block

0x00007f3cb867f30e ssI3_do_compress
0x00007f3cb867f45¢ 0x0000000000000000
0x00007f3cb867f950 ssI3_write_bytes

45.
46.
47.
48.
49.
50.
51.
52.
53.
54.
55.

12 libQtNetwork.s0.4  0x00007f3cba79413f 0x0000000000000000

13 libQtNetwork.s0.4  0x00007f3cba79172c 0x0000000000000000

14 libQtNetwork.s0.4  0x00007f3cba788600 0x0000000000000000

15 libQtNetwork.so.4  0x00007f3cba78b035 QSslSocket::gt_metacall(QMetaObject::Call, int, void**)

16 libQtCore.so0.4 0x00007f3cbabade5¢c QMetaObject::activate(QObject™, int, int, void**)

17 libQtCore.so0.4 0x00007f3cbabaf4f5 QMetaObject::activate(QObject”, QMetaObject const™, int, void*™*)

18 libQtCore.s0.4 0x00007f3cbabf5258 QIODevice::readyRead()

19 libQtNetwork.s0.4  0x00007f3cba76effd 0x0000000000000000

20 libQtNetwork.s0.4  0x00007f3cba77275b 0x0000000000000000

21 libQtNetwork.so.4  0x00007f3cba759463 0x0000000000000000

22 libQtNetwork.s0.4  0x00007f3cba75aed5 0x0000000000000000

56. 23 libQtCore.so0.4 0x00007f3cbab9159a QCoreApplicationPrivate::notify_helper(QObject*, QEvent*)

57.24 libQtCore.so0.4 0x00007f3cbab94b38 QCoreApplication::notify(QObject*, QEvent*)

58. 25 libQtCore.so0.4 0x00007f3cbab9372b QCoreApplication::notifyInternal(QObject*, QEvent*)

59. 26 libQtCore.so0.4 0x00007f3cbab981dd QCoreApplication::sendEvent(QObject*, QEvent*)

60. 27 libQtCore.so0.4 0x00007f3cbabc9ad7 QEventDispatcherUNIX::activateSocketNotifiers()

61. 28 libQtCore.so0.4 0x00007f3cbabcc2fb QEventDispatcherUNIXPrivate::doSelect(QFlags<QEventLoop::ProcessEventsFlag>, timeval*)
62. 29 libQtCore.so0.4 0x00007f3cbabcc476 QEventDispatcherUNIX::processEvents(QFlags<QEventLoop::ProcessEventsFlag>)
63. 30 libQtCore.so0.4 0x00007f3cbab8ffcf QEventLoop::processEvents(QFlags<QEventLoop::ProcessEventsFlag>)
64. 31 libQtCore.so0.4 0x00007f3cbab901de QEventLoop::exec(QFlags<QEventLoop::ProcessEventsFlag>)

65. 32 libQtCore.so0.4 0x00007f3cbab94135 QCoreApplication::exec()

66. 33 quasselcore 0x0000000000472976 main

67.34 libc.so0.6 0x00007f3cb96501a6 __libc_start_main

68. 35 quasselcore 0x0000000000470d49 std::ios_base::Init::~Init()

#3 - 05/09/2009 11:15 AM - tobyS
Another crash log, created with all gt packages, quassel and openssl compiled with "-debug" use flag (Gentoo):
2009-05-09 11:09:24 Debug: Quassel IRC: "0.4.1" "b5798a1041d83a7118b7e9b7cffd4d5307a72d0e"

2009-05-09 11:09:24 Debug: Quassel IRC: "0.4.1" "b5798a1041d83a7118b7e9b7cffd4d5307a72d0e"
2009-05-09 11:09:24 Debug: # 0 quasselcore 0x08141cd3 Quassel::logBacktrace(QString const&)

2009-05-09 11:09:24 Debug: # 0 quasselcore 0x08141cd3 Quassel::logBacktrace(QString const&)
2009-05-09 11:09:24 Debug: # 1 quasselcore 0x08123a44 Quassel::handleSignal(int)
2009-05-09 11:09:24 Debug: # 1 quasselcore 0x08123a44 Quassel::handleSignal(int)
2009-05-09 11:09:24 Debug: # 2 Oxffffe420 __ kernel_sigreturn

2009-05-09 11:09:24 Debug: # 2 Oxffffe420 __ kernel_sigreturn

2009-05-09 11:09:24 Debug: # 3 libz.so.1 0xb789b3fa 0x00000000

2009-05-09 11:09:24 Debug: # 3 libz.so.1 0xb789b3fa 0x00000000

2009-05-09 11:09:24 Debug: # 4 libz.so.1 0xb789bbfc 0x00000000

2009-05-09 11:09:24 Debug: # 4 libz.so.1 0xb789bc41 0x00000000

2009-05-09 11:09:24 Debug: # 5 libz.so.1 0xb78994d6 0x00000000

2009-05-09 11:09:24 Debug: # 5 libz.so.1 0xb78994d6 0x00000000

2009-05-09 11:09:24 Debug: # 6 libz.so.1 0xb7898627 deflate

2009-05-09 11:09:24 Debug: # 6 libz.so.1 0xb7898627 deflate

2009-05-09 11:09:24 Debug: # 7 libcrypto.s0.0.9.8 0xb75125de 0x00000000

2009-05-09 11:09:24 Debug: # 7 libcrypto.s0.0.9.8 0xb75125de 0x00000000

2009-05-09 11:09:24 Debug: # 8 libcrypto.s0.0.9.8 0xb751157e COMP_compress_block
2009-05-09 11:09:24 Debug: # 8 libcrypto.s0.0.9.8 0xb751157e COMP_compress_block
2009-05-09 11:09:24 Debug: # 9 libssl.s0.0.9.8  0xb7576d2b ssI3_do_compress
2009-05-09 11:09:24 Debug: # 9 libssl.s0.0.9.8  0xb7576d2b ssI3_do_compress
2009-05-09 11:09:24 Debug: # 10 libssl.s0.0.9.8  0xb7576e5f 0x00000000

2009-05-09 11:09:24 Debug: # 10 libssl.s0.0.9.8  0xb7576e5f 0x00000000

2009-05-09 11:09:24 Debug:
2009-05-09 11:09:24 Debug:
2009-05-09 11:09:24 Debug:
2009-05-09 11:09:24 Debug:
2009-05-09 11:09:24 Debug:
# 11 libssl.s0.0.9.8
# 11 libssl.s0.0.9.8
# 12 libssl.s0.0.9.8
# 12 libssl.s0.0.9.8
# 13 libssl.s0.0.9.8

0xb7577280 ssI3_write_bytes
0xb7577280 ssI3_write_bytes
0xb75744b2 ssI3_write
0xb75744b2 ssI3_write
0xb75861f9 SSL_write
2009-05-09 11:09:24 Debug
2009-05-09 11:09:24 Debug
2009-05-09 11:09:24 Debug
2009-05-09 11:09:24 Debug
2009-05-09 11:09:24 Debug
2009-05-09 11:09:24 Debug
2009-05-09 11:09:24 Debug
2009-05-09 11:09:24 Debug
2009-05-09 11:09:24 Debug
2009-05-09 11:09:24 Debug
2009-05-09 11:09:24 Debug
2009-05-09 11:09:24 Debug
2009-05-09 11:09:24 Debug
2009-05-09 11:09:24 Debug
2009-05-09 11:09:24 Debug
2009-05-09 11:09:24 Debug
2009-05-09 11:09:24 Debug
2009-05-09 11:09:24 Debug
2009-05-09 11:09:24 Debug
2009-05-09 11:09:24 Debug
2009-05-09 11:09:24 Debug
2009-05-09 11:09:24 Debug
2009-05-09 11:09:24 Debug
2009-05-09 11:09:24 Debug
2009-05-09 11:09:24 Debug
2009-05-09 11:09:24 Debug
2009-05-09 11:09:24 Debug
2009-05-09 11:09:24 Debug
2009-05-09 11:09:24 Debug
2009-05-09 11:09:24 Debug
2009-05-09 11:09:24 Debug
2009-05-09 11:09:24 Debug
2009-05-09 11:09:24 Debug
2009-05-09 11:09:24 Debug
2009-05-09 11:09:24 Debug
2009-05-09 11:09:24 Debug
2009-05-09 11:09:24 Debug
2009-05-09 11:09:24 Debug
2009-05-09 11:09:24 Debug
2009-05-09 11:09:24 Debug
2009-05-09 11:09:24 Debug
2009-05-09 11:09:24 Debug
2009-05-09 11:09:24 Debug
2009-05-09 11:09:24 Debug
2009-05-09 11:09:24 Debug
2009-05-09 11:09:24 Debug
2009-05-09 11:09:24 Debug
2009-05-09 11:09:24 Debug
2009-05-09 11:09:24 Debug
2009-05-09 11:09:24 Debug

1 # 13 libssl.s0.0.9.8  0xb75861f9 SSL_write

:# 14 libQtNetwork.so.4  0xb7cefd22 0x00000000

1 # 14 libQtNetwork.s0.4  0xb7cefd22 0x00000000

1 # 15 libQtNetwork.so.4  0xb7ced27f 0x00000000

1 # 15 libQtNetwork.s0.4  0xb7ced27f 0x00000000

1 # 16 libQtNetwork.s0.4  0xb7ce65c8 QSsISocket::flush()

: # 16 libQtNetwork.so.4  0xb7ce5f98 0x00000000

1 # 17 libQtNetwork.s0.4  0xb7ce6608 0x00000000

1 # 17 libQtNetwork.s0.4  0xb7ce9006 QSslSocket::qt_metacall(QMetaObject::Call, int, void**)

1 # 18 libQtNetwork.s0.4  0xb7ce8fd6 QSslSocket::gt_metacall(QMetaObject::Call, int, void**)

: # 18 libQtCore.s0.4 0xb7e5db8e QMetaObiject::activate(QObject*, int, int, void**)

1 #19 libQtCore.s0.4 0xb7e58ca9 QMetaCallEvent::placeMetaCall(QObject*)

:# 19 libQtCore.s0.4 0xb7e5e104 QMetaObject::activate(QObject*, QMetaObject const*, int, void**)

:# 20 libQtCore.s0.4 0xb7e59f57 QObject::event(QEvent®)

1 # 20 libQtCore.s0.4 0xb7e93623 QIODevice::readyRead()

1 # 21 libQtCore.s0.4 0xb7e4b4a3 QCoreApplicationPrivate::notify_helper(QObject*, QEvent*)

:# 21 libQtNetwork.s0.4  0xb7cd150d 0x00000000

1 # 22 libQtCore.s0.4 0xb7e4b513 QCoreApplication::notify(QObject*, QEvent*)

: # 22 libQtNetwork.s0.4  0xb7cd4de1 0x00000000

: # 23 libQtCore.s0.4 0xb7e4b09a QCoreApplication::notifyInternal(QObject*, QEvent*)

: # 23 libQtNetwork.s0.4  0xb7cc107b 0x00000000

1 # 24 libQtCore.s0.4 0xb7e4bfb6 QCoreApplicationPrivate::sendPostedEvents(QObject”, int, QThreadData*)
: # 24 libQtNetwork.s0.4  0xb7cc2d5f 0x00000000

: # 25 libQtCore.s0.4 0xb7e4c1ad QCoreApplication::sendPostedEvents(QObject*, int)

1 # 25 libQtCore.s0.4 0xb7e4b4a3 QCoreApplicationPrivate::notify_helper(QObject*, QEvent*)

1 # 26 libQtCore.s0.4 0xb7e715dd 0x00000000

1 # 26 libQtCore.s0.4 0xb7e4b513 QCoreApplication::notify(QObject*, QEvent*)

1 # 27 libglib-2.0.s0.0  O0xb77eaflb g_main_context_dispatch

:# 27 libQtCore.s0.4 0xb7e4b09a QCoreApplication::notifyInternal(QObject*, QEvent*)

1 # 28 libglib-2.0.s0.0  0xb77ee41f 0x00000000

1 # 29 libglib-2.0.s0.0  0xb77ee€997 g_main_context_iteration

1 # 28 libQtCore.s0.4 0xb7e71a4d 0x00000000

1 # 30 libQtCore.s0.4 0xb7e71b98 QEventDispatcherGlib::processEvents(QFlags<QEventLoop::ProcessEventsFlag>)
1 # 29 libglib-2.0.s0.0  0xb77eaflb g_main_context_dispatch

1 # 31 libQtCore.so0.4 0xb7e4a36d QEventLoop::processEvents(QFlags<QEventLoop::ProcessEventsFlag>)
1 # 30 libglib-2.0.s0.0  0xb77ee41f 0x00000000

1 # 32 libQtCore.s0.4 0Oxb7e4a51a QEventLoop::exec(QFlags<QEventLoop::ProcessEventsFlag>)

1 # 31 libglib-2.0.s0.0  0xb77ee997 g_main_context_iteration

: # 33 libQtCore.s0.4 0xb7d6¢c301 QThread::exec()

1 # 32 libQtCore.s0.4 0xb7e71b98 QEventDispatcherGlib::processEvents(QFlags<QEventLoop::ProcessEventsFlag>)
: # 34 quasselcore 0x0808cab58 SessionThread::run()

: # 33 libQtCore.s0.4 0xb7e4a36d QEventLoop::processEvents(QFlags<QEventLoop::ProcessEventsFlag>)

: # 35 libQtCore.s0.4 0xb7d6f00d 0x00000000
1 # 34 libQtCore.so.4 0xb7e4ab1a QEventLoop::exec(QFlags<QEventLoop::ProcessEventsFlag>)
: # 36 libpthread.s0.0  0xb77a019b 0x00000000

: # 35 libQtCore.s0.4 0xb7e4c26a QCoreApplication::exec()

: # 37 libc.so0.6 0xb797286¢ clone
: # 36 quasselcore 0x080764ac main
1 # 37 libc.so.6 0xb78c160c __libc_start_main

: # 38 quasselcore 0x08075c41 QObject::event(QEvent*)

#4 - 07/11/2009 03:08 PM - seezer

Ok, | have a little update on that.
Thought fix e042ae69dbe4f42e9e4441f4b5832cfe5ca89067 didn't help.

| even tried it with a blocking

version of socket->flush() but that didn't fix it either.

But it helped getting the crash into the main thread which then got me the attention of thiago ;)

He told me where our problem is:
moveToThread is actually called via a signal of the socket to be moved

In detail:
QSslSocketBackendPrivate:

:transmit causes QIODevice::readyRead etc.

If transmit hasn't finished until the thread is moved, two threads use the same socket.

Background:

thiago explained to me that QSsISocket needs 4 transmit operations:

from the unencrypted buffer

into the SSL engine, from the SSL engine into the socket

from the socket into the SSL engine, from the SSL engine into the decrypted buffer

The backtrace showing the behaviour:

Breakpoint 1,

SessionThread: :addRemoteClientToSession

(this=0x1ff6430, socket=0x7fe494318a30) at /home/quassel

/quasselsource/src/core/sessionthread.cpp: 90
90 socket->moveToThread (session () —>thread());
(gdb) bt 0x7fe494318a30

#0 SessionThread::addRemoteClientToSession (this=0x1ff6430, socket=0x7fe494318a30) at /home/quassel/quasselso
urce/src/core/sessionthread.cpp: 90
#1 0x00000000004c0592 in SessionThread::addClientToSession (this=0x1ff6430, peer=0x7fe494318a30) at /home/qua
ssel/quasselsource/src/core/sessionthread.cpp:75
#2 0x00000000004c0692 in SessionThread::addClient (this=0x1ff6430, peer=0x7fe494318a30) at /home/quassel/quas
selsource/src/core/sessionthread.cpp: 66
#3 0x0000000000477ed4e in Core::setupClientSession (this=0x1fc9dal, socket=0x7fe494318a30, uid={<SignedId> = {
id = 1}, <No data fields>})

at /home/quassel/quasselsource/src/core/core.cpp:693

#4 0x00000000004817e8 in Core::processClientMessage (this=0x1fc9da0, socket=0x7fe494318a30, msg=@0x7fffebcl06
50) at /home/quassel/quasselsource/src/core/core.cpp:620
#5 0x000000000048190e in Core::clientHasData (this=0x1fc9dal) at /home/quassel/quasselsource/src/core/core.cp
p:488
#6 0x00000000004e7bad4 in Core::gt_metacall (this=0x1fc9dal0, _c=QMetaObject::InvokeMetaMethod, _id=12, _a=0x7f
ffebcl10840)

at /home/quassel/quasselsource/build/src/core/moc_core.cxx:117

#7 0x00007fed9ee28b44 in QMetaObject::activate (sender=0x7fe494318a30, from_signal_index=4, to_signal_index=4
, argv=0x0) at kernel/gobject.cpp:3104

#8 0x00007fed49ee2a285 in QMetaObject::activate (sender=0x7fe494318a30, m=0x85f700, local_signal_index=0, argv
=0x0) at kernel/gobject.cpp:3178

#9 0x00007fed9ee6ffb0 in QIODevice::readyRead (this=0x7fe494318a30) at .moc/debug-shared/moc_giodevice.cpp:85

#10 0x00007fed9eala8lc in QSslSocketBackendPrivate::transmit (this=0x7fe4945c9140) at ssl/gsslsocket_openssl.c
pp:668
#11 0x00007fe49ea01110 in QSslSocketPrivate::_g_readyReadSlot (this=0x7fe4945c9140) at ssl/gsslsocket.cpp:2010

#12 0x00007fe49ea03b83 in QSslSocket::gt_metacall (this=0x7fe494318a30, _c=QMetaObject::InvokeMetaMethod, _id=
15, _a=0x7fffebcllb50) at .moc/debug-shared/moc_gsslsocket.cpp:114

#13 0x00007fed49ee28b44 in QMetaObject::activate (sender=0x7fe494557fa0, from_signal_index=4, to_signal_index=4
, argv=0x0) at kernel/gobject.cpp:3104

#14 0x00007fed49ee2a285 in QMetaObject::activate (sender=0x7fe494557fa0, m=0x85f700, local_signal_index=0, argv
=0x0) at kernel/gobject.cpp:3178

#15 0x00007fed9ee6ffb0 in QIODevice::readyRead (this=0x7fe494557fa0) at .moc/debug-shared/moc_giodevice.cpp:85

#16 0x00007fed9e9e7b89 in QAbstractSocketPrivate::canReadNotification (this=0x7fe4945c8b90) at socket/gabstrac
tsocket.cpp:604

#17 0x00007fed9e9eb2f5 in QAbstractSocketPrivate::readNotification (this=0x7fe4945c8b90) at ../../include/QtNe
twork/private/../../../src/network/socket/gabstractsocket_p.h:77

#18 0x00007fed9e9dlfeb in QAbstractSocketEngine::readNotification (this=0x7fed4944532f0) at socket/gabstractsoc
ketengine.cpp:154

#19 0x00007fed9e9d3a5d in QReadNotifier::event (this=0x7fed4944da550, e=0x7fffebclled0) at socket/gnativesocket
engine.cpp:1036

#20 0x00007fed9eelc34a in QCoreApplicationPrivate::notify_helper (this=0xlfaclf0, receiver=0x7fed4944da550, eve
nt=0x7fffebclled40) at kernel/qcoreapplication.cpp:746

#21 0x00007fe49ee0£f848 in QCoreApplication::notify (this=0x7fffebcl23d0, receiver=0x7fe4944da550, event=0x7fff
ebclled0) at kernel/gcoreapplication.cpp:692

#22 0x00007fe49eeled3b in QCoreApplication::notifyInternal (this=0x7fffebcl123d0, receiver=0x7fed944da550, even
t=0x7fffebclled40) at kernel/qgcoreapplication.cpp:610

#23 0x00007fed9eel2eed in QCoreApplication::sendEvent (receiver=0x7fe4944da550, event=0x7fffebclled40) at ../..
/include/QtCore/../../src/corelib/kernel/qcoreapplication.h:213

#24 0x00007fed9eed4893 in QEventDispatcherUNIX::activateSocketNotifiers (this=0xlfabad0) at kernel/geventdispa
tcher_unix.cpp:862

#25 0x00007fe49eed70b7 in QEventDispatcherUNIXPrivate::doSelect (this=0x1fad750, flags={i = -339664736}, timeo
ut=0x7fffebcl2070) at kernel/geventdispatcher_unix.cpp:250

#26 0x00007fed49eed7232 in QEventDispatcherUNIX: :processEvents (this=0xlfabad0, flags={i = -339664624}) at kern
el/geventdispatcher_unix.cpp:904

#27 0x00007fed9eelad5f in QEventLoop::processEvents (this=0x7fffebcl21f0, flags={i = -339664512}) at kernel/qge
ventloop.cpp:149

#28 0x00007fed9eelaf83 in QEventLoop::exec (this=0x7fffebcl21f0, flags={i = -339664384}) at kernel/geventloop.
cpp:201

#29 0x00007fed49eeleed5 in QCoreApplication::exec () at kernel/gcoreapplication.cpp:888

#30 0x0000000000472d36 in main (argc=9, argv=0x7fffebcl2848) at /home/quassel/quasselsource/src/common/main.cp
p:144

And another backtrace of a crash showing two threads using the same socket:

Note the "strm" or "s" variable in deflate(|_slow):

Thread 8 (Thread 0x41ed5950 (LWP 1091)):
#0 deflate_slow (s=0x7f41982f3de0, flush=2) at deflate.c:1669
#1 0x00007f41la82cc28d in deflate (strm=0x7£f41982df3c0, flush=2) at deflate.c:822

#2 0x00007f41a76e388e in ?7? () from /usr/lib/libcrypto.so0.0.9.8

#3 0x00007f4la76e34f2 in COMP_compress_block () from /usr/lib/libcrypto.so.0.9.8

#4 0x00007£f41a739330e in ssl3_do_compress () from /usr/lib/libssl.so.0.9.8

#5 0x00007£f41a739345c in ?? () from /usr/lib/libssl.so0.0.9.8

#6 0x00007f41a7393950 in ssl3_write_bytes () from /usr/lib/libssl.so0.0.9.8

#7 0x00007£f41a9815e6d in QSslSocketBackendPrivate::transmit (this=0x7£41982b5410) at ssl/gsslsocket_openssl.c
pp:566

#8 0x00007£f41a980d601 in QSslSocket::flush (this=<value optimized out>) at ssl/gsslsocket.cpp:693

#9 0x00007£f41a98111b2 in QSslSocket::gt_metacall (this=0x7£41982994d0, _c=QMetaObject::InvokeMetaMethod, _id=
<value optimized out>, _a=0x7f419836f640)
at .moc/release-shared/moc_gsslsocket.cpp:116

#10 0x00007f41a9bd4f58 in QObject::event (this=0x7£f41982994d0, e=0x7£f4198259230) at kernel/gobject.cpp:1102

#11 0x00007f4laSbcbaec in QCoreApplication::notifyInternal (this=0x7f£f£327c11d0, receiver=0x7£41982994d0, even
t=0x7£4198259230) at kernel/gcoreapplication.cpp:610
#12 0x00007f41a9bc6672 in QCoreApplicationPrivate::sendPostedEvents (receiver=0x0, event_type=0, data=0x172624
0)

at ../../include/QtCore/../../src/corelib/kernel/gcoreapplication.h:213

#13 0x00007f4la9beffcO in QEventDispatcherUNIX: :processEvents (this=0x1720750, flags={i = 1106071600}) at kern
el/geventdispatcher_unix.cpp:876

#14 0x00007f4la9bc45a2 in QEventLoop::processEvents (this=<value optimized out>, flags={i = 1106071648}) at ke
rnel/geventloop.cpp:149

#15 0x00007f41a9bc4974 in QEventLoop::exec (this=0x41led50a0, flags={i = 1106071728}) at kernel/geventloop.cpp:
201

#16 0x00007f41la9adbd58 in QThread::exec (this=<value optimized out>) at thread/gthread.cpp:487

#17 0x00000000004c03b9 in SessionThread::run (this=0x1720a70) at /home/quassel/quasselsource/src/core/sessiont
hread.cpp:105
#18 0x00007f4la9adeal5 in QThreadPrivate::start (arg=0x1720a70) at thread/gthread_unix.cpp:188

#19 0x00007f4la7ea7fc7 in start_thread () from /lib/libpthread.so.0
#20 0x00007f41a87b05ad in clone () from /lib/libc.so.6

#21 0x0000000000000000 in 2?2 ()

[...]

Thread 1 (Thread 0x7f41aaObd6f0 (LWP 1085)):

#0 deflate_slow (s=0x7f41982f3de0, flush=2) at deflate.c:1669

#1 0x00007f41la82cc28d in deflate (strm=0x7£f41982df3c0, flush=2) at deflate.c:822

#2 0x00007f41a76e388e in ?7? () from /usr/lib/libcrypto.so0.0.9.8

#3 0x00007f4la76e34f2 in COMP_compress_block () from /usr/lib/libcrypto.so.0.9.8

#4 0x00007£f41a739330e in ssl3_do_compress () from /usr/lib/libssl.so.0.9.8

#5 0x00007£f41a739345c in ?? () from /usr/lib/libssl.so0.0.9.8

#6 0x00007f41a7393950 in ssl3_write_bytes () from /usr/lib/libssl.so0.0.9.8

#7 0x00007£f41a9815e6d in QSslSocketBackendPrivate::transmit (this=0x7£41982b5410) at ssl/gsslsocket_openssl.c
pp:566

#8 0x00007f41a98111e2 in QSslSocket::gt_metacall (this=0x7£41982994d0, _c=QMetaObject::InvokeMetaMethod, _id=
<value optimized out>, _a=0x7f££327c0cd0)
at .moc/release-shared/moc_gsslsocket.cpp:114

#9 0x00007f41a9bd9972 in QMetaObject::activate (sender=0x7f41982abeel, from_signal_index=<value optimized out
>, to_signal_index=4, argv=0x1470) at kernel/qgobject.cpp:3104

#10 0x00007£f41a97£f784f in QAbstractSocketPrivate::canReadNotification (this=0x7f41982abf20) at socket/gabstrac
tsocket.cpp:604

#11 0x00007f41a97e65f1 in QReadNotifier::event (this=<value optimized out>, e=0x7£f41985cf4al) at socket/gnativ
esocketengine.cpp:1036

#12 0x00007f4la9bcbaec in QCoreApplication::notifyInternal (this=0x7f£f£327c11d0, receiver=0x7£41982b0790, even
t=0x7£££327c0db0) at kernel/qgcoreapplication.cpp:610

#13 0x00007f4la9beel3ca in QEventDispatcherUNIX::activateSocketNotifiers (this=<value optimized out>) at ../../
include/QtCore/../../src/corelib/kernel/qcoreapplication.h:213

#14 0x00007f4la9beebd6 in QEventDispatcherUNIXPrivate::doSelect (this=0x16cb760, flags={i = 846991168}, timeou
t=0x7££f£327c0£30) at kernel/geventdispatcher_unix.cpp:250

#15 0x00007£f41a9bf002d in QEventDispatcherUNIX: :processEvents (this=0xl6cb740, flags={i = 846991232}) at kerne
1/geventdispatcher_unix.cpp: 904

#16 0x00007f4la9bc4d45a2 in QEventLoop::processEvents (this=<value optimized out>, flags={i = 846991280}) at ker
nel/geventloop.cpp:149

#17 0x00007f41a9bc4974 in QEventLoop::exec (this=0x7f£f£327c0ff0, flags={i = 846991360}) at kernel/geventloop.c
pp:201

#18 0x00007f41a9bc6916 in QCoreApplication::exec () at kernel/gcoreapplication.cpp:888
#19 0x0000000000472d36 in main (argc=9, argv=0x7fff327cl648) at /home/quassel/quasselsource/src/common/main.cp
p:144

So we have to make sure that we're outside of the signal-called function calls and that should do the trick.
Who got the best idea how to do that? :)

#5 - 07/11/2009 03:10 PM - seezer

- Status changed from New to Confirmed
- Priority changed from Normal to High

- Version changed from 0.4.0 to 0.5-pre

- OS changed from Linux to Any

#6 - 07/12/2009 03:21 PM - EgS
- Status changed from Confirmed to Resolved

- % Done changed from 0 to 100

Applied in changeset e049ffc61b5e260a49d73102a74c3821af827e77.
